
/*****************************************************************************
 * As a small demonstration of the power of loop invariants, the following 
 * program gets a positive integer from the user and has two attempts at 
 * returning the largest power of 2 less than or equal to the value 
 *****************************************************************************/
#include <iostream>

using std::cin;         using std::endl;
using std::cout;       

int main()
{
	int num=-1;
	// Get a positive integer from the keyboard.
	// 'num' holds the current attempt.

	while(num<=0)
	{
		cout << "Please enter a positive integer: ";
		cin>>num;
		if(num<=0)
		{
			cout<<num<<" is not postive. ";
			cout<<"You know, this shouldn't be hard. ";
		}
	}

	
	// This is the first try. Can you devise a loop inveriant for it?
	int pow=1;

	while( pow<num )
		pow*=2;
	cout<<"\nThe largest power of 2 less than or equal to "
		<<num<<" is "<<pow<<", I hope.\n";

	// This is the second try. Can you devise a loop inveriant for it?
	pow=1;

	while( 2*pow<=num )
		pow*=2;
	cout<<"\nThe largest power of 2 less than or equal to "
		<<num<<" is "<<pow<<", I hope.\n";
	

	// Second try
		
		
		
	return 0;
}
	


